org.codehaus.plexus.compiler

## Interface Compiler

- All Known Implementing Classes:
    AbstractCompiler, CSharpCompiler, EclipseJavaCompiler, JavacCompiler, JikesCompiler

      public interface Compiler

  Version:
    $Id$
  Author:
    Jason van Zyl, Trygve Laugstøl, Matthew Pocock

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `ROLE`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canUpdateTarget(CompilerConfiguration configuration)`
    `List<CompilerError>` | `compile(CompilerConfiguration configuration)`
    `String[]` | `createCommandLine(CompilerConfiguration config)` Create the command line that would be executed using this configuration.
    `CompilerOutputStyle` | `getCompilerOutputStyle()`
    `String` | `getInputFileEnding(CompilerConfiguration configuration)`
    `String` | `getOutputFile(CompilerConfiguration configuration)`
    `String` | `getOutputFileEnding(CompilerConfiguration configuration)`

- - ### Field Detail

    - #### ROLE

          static final String ROLE

  - ### Method Detail

    - #### getCompilerOutputStyle

          CompilerOutputStyle getCompilerOutputStyle()

    - #### getInputFileEnding

          String getInputFileEnding(CompilerConfiguration configuration)
                                    throws CompilerException

      Throws:
        `CompilerException`

    - #### getOutputFileEnding

          String getOutputFileEnding(CompilerConfiguration configuration)
                                     throws CompilerException

      Throws:
        `CompilerException`

    - #### getOutputFile

          String getOutputFile(CompilerConfiguration configuration)
                               throws CompilerException

      Throws:
        `CompilerException`

    - #### canUpdateTarget

          boolean canUpdateTarget(CompilerConfiguration configuration)
                                  throws CompilerException

      Throws:
        `CompilerException`

    - #### compile

          List<CompilerError> compile(CompilerConfiguration configuration)
                                      throws CompilerException

      Throws:
        `CompilerException`

    - #### createCommandLine

          String[] createCommandLine(CompilerConfiguration config)
                                     throws CompilerException

      Create the command line that would be executed using this configuration. If this particular compiler has no concept of a command line then returns null.
      Parameters:
        `config` - the CompilerConfiguration describing the compilation
      Returns:
        an array of Strings that make up the command line, or null if this compiler has no concept of command line
      Throws:
        `CompilerException` - if there was an error generating the command line

Copyright © 2015. All rights reserved.